package com.hai.dao;

import com.hai.entity.HighPayRecord;
import com.hai.entity.HighPayRecordExample.Criteria;
import com.hai.entity.HighPayRecordExample.Criterion;
import com.hai.entity.HighPayRecordExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighPayRecordSqlProvider {

    public String countByExample(HighPayRecordExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_pay_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighPayRecordExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_pay_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighPayRecord record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_pay_record");
        
        if (record.getPaySerialNo() != null) {
            sql.VALUES("pay_serial_no", "#{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getResType() != null) {
            sql.VALUES("res_type", "#{resType,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayMoney() != null) {
            sql.VALUES("pay_money", "#{payMoney,jdbcType=DECIMAL}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getBodyInfo() != null) {
            sql.VALUES("body_info", "#{bodyInfo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayResult() != null) {
            sql.VALUES("pay_result", "#{payResult,jdbcType=VARCHAR}");
        }
        
        if (record.getFailCode() != null) {
            sql.VALUES("fail_code", "#{failCode,jdbcType=VARCHAR}");
        }
        
        if (record.getFailReason() != null) {
            sql.VALUES("fail_reason", "#{failReason,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighPayRecordExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("pay_serial_no");
        sql.SELECT("res_type");
        sql.SELECT("pay_type");
        sql.SELECT("pay_money");
        sql.SELECT("pay_time");
        sql.SELECT("body_info");
        sql.SELECT("pay_result");
        sql.SELECT("fail_code");
        sql.SELECT("fail_reason");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_pay_record");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighPayRecord record = (HighPayRecord) parameter.get("record");
        HighPayRecordExample example = (HighPayRecordExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_pay_record");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getResType() != null) {
            sql.SET("res_type = #{record.resType,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayMoney() != null) {
            sql.SET("pay_money = #{record.payMoney,jdbcType=DECIMAL}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getBodyInfo() != null) {
            sql.SET("body_info = #{record.bodyInfo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayResult() != null) {
            sql.SET("pay_result = #{record.payResult,jdbcType=VARCHAR}");
        }
        
        if (record.getFailCode() != null) {
            sql.SET("fail_code = #{record.failCode,jdbcType=VARCHAR}");
        }
        
        if (record.getFailReason() != null) {
            sql.SET("fail_reason = #{record.failReason,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_pay_record");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        sql.SET("res_type = #{record.resType,jdbcType=INTEGER}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("pay_money = #{record.payMoney,jdbcType=DECIMAL}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("body_info = #{record.bodyInfo,jdbcType=VARCHAR}");
        sql.SET("pay_result = #{record.payResult,jdbcType=VARCHAR}");
        sql.SET("fail_code = #{record.failCode,jdbcType=VARCHAR}");
        sql.SET("fail_reason = #{record.failReason,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighPayRecordExample example = (HighPayRecordExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighPayRecord record) {
        SQL sql = new SQL();
        sql.UPDATE("high_pay_record");
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getResType() != null) {
            sql.SET("res_type = #{resType,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayMoney() != null) {
            sql.SET("pay_money = #{payMoney,jdbcType=DECIMAL}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getBodyInfo() != null) {
            sql.SET("body_info = #{bodyInfo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayResult() != null) {
            sql.SET("pay_result = #{payResult,jdbcType=VARCHAR}");
        }
        
        if (record.getFailCode() != null) {
            sql.SET("fail_code = #{failCode,jdbcType=VARCHAR}");
        }
        
        if (record.getFailReason() != null) {
            sql.SET("fail_reason = #{failReason,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighPayRecordExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}